#ifndef __BuddhaGpuEffectPass_H__
#define __BuddhaGpuEffectPass_H__

#include "BuddhaEffectPass.h"
#include "BuddhaGpuEffect.h"

namespace BuddhaLib
{
	class GpuEffectTechnique;

	/// vO}uVF[_p̃GtFNgpX
	class GpuEffectPass : public EffectPass
	{
		friend GpuEffectTechnique;

	protected:
		GpuEffect* m_pEffect;

		unsigned int mPass;

		GpuEffectPass(GpuEffect *effect, unsigned int pass)
			: m_pEffect(effect),
			  mPass(pass)
		{
		}

	public:
		void Begin(void)
		{
			m_pEffect->m_pEffect->BeginPass(mPass);
		}

		void End(void)
		{
			m_pEffect->m_pEffect->EndPass();
		}

		virtual bool _isGpuEffect(void) const
		{
			return true;
		}
	};
}

#endif