#ifndef __BuddhaHardwareEffectPass_H__
#define __BuddhaHardwareEffectPass_H__

#include "BuddhaEffect.h"
#include "BuddhaHardwareEffect.h"
#include "BuddhaHardwareEffectLight.h"

namespace BuddhaLib
{
	/// HardwareEffect p̃GtFNgpX
	class HardwareEffectPass : EffectPass
	{
		friend HardwareEffectTechnique;

	protected:
		 HardwareEffectPass(HardwareEffect* effect)
			: m_pEffect(effect)
		 {
		 }

		 HardwareEffect* m_pEffect;

	public:
		~HardwareEffectPass(){}

		void Begin(void);

		void End(void);

		inline bool _isGpuEffect(void) const
		{
			return false;
		}
	};
}

#endif
