#ifndef __BuddhaPrerequisites_H__
#define __BuddhaPrerequisites_H__

#ifndef STRICT
#define STRICT
#endif


#define	BUDDHALIB_VERSION	(0.0100)

typedef double Real;

#include <string>

#include <sstream>
#include <iostream>

typedef std::string AsciiString;
typedef std::stringstream AsciiStringSteam;

typedef std::wstring String;
typedef std::wstringstream StringStream;

// Because BuddhaLib does not have defined Color struct.
#include <d3dx9.h>

#include "BuddhaLibException.h"

#ifndef SAFE_RELEASE
#define SAFE_RELEASE(x)	{ if (x) { (x)->Release(); (x)=NULL; } }
#endif

#ifndef SAFE_DELETE
#define SAFE_DELETE(x) { if (x != NULL) { delete (x); (x)=NULL; } }
#endif

#ifndef SAFE_DELETES
#define SAFE_DELETES(x) { if (x != NULL) { delete[] (x); (x)=NULL; } }
#endif

#endif