#ifndef __BuddhaModelMeshPart_H__
#define __BuddhaModelMeshPart_H__

#include "BuddhaVertexDeclaration.h"

namespace BuddhaLib
{
	class Model;

	/** @brief _OɃOtBbNfoCXɑoWIg̃ob`B
	 *
	 * e ModelMeshPart  ModelMesh IuWFNg̃TufBrWłBʓI ModelMesh NX
	 * }eAɊÂĕ ModelMeshPart IuWFNgɕ܂B
	 */
	class ModelMeshPart
	{
		friend Model;

	public:
		ModelMeshPart() : 
		  mAttributeId(0)
		{
		}

		virtual ~ModelMeshPart()
		{
		}

		int GetPrimitiveCount(void) const
		{
			return mPrimitiveCount;
		}

		int GetStartIndex(void) const
		{
			return mStartIndex;
		}

		VertexDeclaration* GetVertexDeclaration() const
		{
			return mVertexDeclaration.GetPointer();
		}

		VertexDeclarationPtr GetVertexDeclarationPtr(void) const
		{
			return mVertexDeclaration;
		}

		int GetVertexStride(void) const
		{
			return mVertexStride;
		}

		int GetAttributeId(void) const
		{
			return mAttributeId;
		}

		int GetBaseVertex(void) const
		{
			return mBaseVertex;
		}

		int GetNumVertex(void) const
		{
			return mNumVertices;
		}

	protected:
		int mBaseVertex;
		int mNumVertices;
		int mPrimitiveCount;
		int mStartIndex;
		VertexDeclarationPtr mVertexDeclaration;
		int mVertexStride;

		/// Agr[g ID
		int mAttributeId;
	};
}

#endif
