#ifndef __BuddhaTriangle_H__
#define __BuddhaTriangle_H__

#include "BuddhaVector3.h"

namespace BuddhaLib
{
	struct Ray;

	/**
	 * @brief _A, B, CȂOp`
	 */
	struct Triangle
	{
	public:
		Vector3	A;
		Vector3	B;
		Vector3	C;

	private:
		/// ʂ̌̃LbV
		mutable Vector3 mNormal;

		/// LbV̗L
		mutable bool mOutOfDateNormal;

	public:
		Triangle(void)
			: mOutOfDateNormal(true)
		{
		}

		/**
		 * @brief CƃgCAOĂ邩ǂׂ
		 * @return ĂƂ true Ԃ
		 */
		bool Intersects(const Ray &ray) const;

		/**
		 * @brief Op`̐ʂ̌Ԃ
		 */
		const Vector3 &Normal(void) const;
	};
}


#endif