#ifndef __BuddhaEffectTechnique_H__
#define __BuddhaEffectTechnique_H__

#include "BuddhaLibPrerequisites.h"

#include <vector>

namespace BuddhaLib
{
	class Effect;
	class BasicEffect;
	class EffectPass;
	class GpuEffect;

	/// eNjbNC^[tFCX
	class EffectTechnique
	{
	public:
		typedef std::vector<EffectPass*> EffectPassList;

	protected:
		EffectTechnique(void);
		EffectPassList mEffectPassList;

	public:
		virtual ~EffectTechnique();

		/// eNjbNGtFNgpX̍ől擾
		virtual int GetNumPasses(void) = NULL;

		/// w肵CfbNX̃GtFNgpX擾
		virtual EffectPass* GetPass(unsigned int idx) = NULL;
	};
}

#endif