#ifndef __BuddhaGameServiceContainer_H__
#define __BuddhaGameServiceContainer_H__

#include "BuddhaLibPrerequisites.h"

#include <map>

namespace BuddhaLib
{
	class Game;

	/**
	 * @internal
	 */
	class GameServiceContainer
	{
	public:
		typedef std::map<String, void*> ServiceMap;

	protected:
		ServiceMap mServiceMap;

	private:
		GameServiceContainer(void);
		~GameServiceContainer(void);

		friend Game;

	public:
		void AddService(String &type, void* pService);
		void* GetService(String &type);
	};
}

#endif