#ifndef __BuddhaLibException_H__
#define __BuddhaLibException_H__

#include "BuddhaLibPrerequisites.h"

namespace BuddhaLib
{
	class Exception
	{
	protected:
		String mMessage;

	public:
		Exception(void)
			: mMessage(L"")
		{
		}

		Exception(String &message)
			: mMessage(message)
		{
		}

		Exception(LPCWSTR message)
			: mMessage(message)
		{
		}

		virtual String GetMessage(void) const
		{
			return mMessage;
		}
	};

	/// vfWOɂꍇɔsO
	class ArgumentOutOfRangeException : public Exception
	{
	public:
		ArgumentOutOfRangeException(){}
	};

	/// OtBbNfoCX͎ꂢ邪A܃ZbgłȂBă_O͕s\łB
	class DeviceLostException : public Exception
	{
	public:
		DeviceLostException(void)
			: Exception(L"OtBbNfoCX͎Ă܂A̓Zbgł܂Bă_O̎s͕s\łB")
		{
		}

		DeviceLostException(String &message)
			: Exception(message)
		{
		}
	};

	class DeviceNotResetException : public Exception
	{
	public:
		DeviceNotResetException(void)
			: Exception(L"OtBbNfoCX͎Ă܂AZbg\łB")
		{
		}

		DeviceNotResetException(String &message)
			: Exception(message)
		{
		}
	};

	class ArgumentException : public Exception
	{
	public:
		ArgumentException(void)
			: Exception(L"\bhɒ񋟂ꂽp[^̂̂ЂƂȏオLł͂܂")
		{
		}
	};

	class FileNotFoundException : public Exception
	{
	public:
		FileNotFoundException(void)
			: Exception(L"w肳ꂽt@C܂ł")
		{
		}
	};

	class ArgumentNullException : public Exception
	{
	public:
		ArgumentNullException(void)
			: Exception(L"vfɃk܂")
		{
		}
	};
}


#endif
