#ifndef __BuddhaMouse_H__
#define __BuddhaMouse_H__

#include "BuddhaLibPrerequisites.h"
#include <dinput.h>

namespace BuddhaLib
{
	class Mouse;

	/// }EX͑uɂċL^ꂽ}EX̏Ԃ\܂B
	struct MouseState
	{
		friend Mouse;
	public:
		enum ButtonState
		{
			BUTTONSTATE_PRESSED,
			BUTTONSTATE_RELEASED
		};

	protected:
		ButtonState	mLeftButton;
		ButtonState	mMiddleButton;
		ButtonState	mRightButton;
		int mX;
		int mY;

	public:
		MouseState()
			: mLeftButton(BUTTONSTATE_RELEASED),
			  mMiddleButton(BUTTONSTATE_RELEASED),
			  mRightButton(BUTTONSTATE_RELEASED),
			  mX(0), mY(0)
		{
		}

		~MouseState()
		{
		}

		/// Xւ̑ΓIȈړʂ擾
		inline int GetX(void) const
		{
			return mX;
		}

		/// Yւ̑ΓIȈړʂ擾
		inline int GetY(void) const
		{
			return mY;
		}

		/// }EX̍{^̏Ԃ擾
		inline ButtonState GetLeftButton(void) const
		{
			return mLeftButton;
		}

		/// }EX̒{^̏Ԃ擾
		inline ButtonState GetMiddleButton(void) const
		{
			return mMiddleButton;
		}

		/// }EX̉E{^̏Ԃ擾
		inline ButtonState GetRightButton(void) const
		{
			return mRightButton;
		}
	};

	class Game;

	/**
	 * @brief }EX̓foCX}EX̏Ԃ̎擾s܂
	 * @attention
	 *     }EX̓foCX擾}EX̏Ԃ́At[ɍXV܂A GetState() ł͍XV
	 *     ܂BfoCX̏AXVAVbg_Eij͓ŕĂA Game NX玩IɃR
	 *     g[܂B
	 */
	class Mouse
	{
		friend Game;

	private:
		/**
		 * @internal
		 */
		Mouse(void);

		static MouseState _mState;

		static LPDIRECTINPUTDEVICE8 m_pInputDevice;

		/**
		 * @brief m_pInputDevice ̏s
		 * @return Ɏsꍇ false Ԃ
		 * @remarks
		 *     ̓foCX̊mێiɂẮAmۂɎsꍇB
		 *     Ẵ\bh͏ɎsĂOX[ȂB
		 * @attention
		 *     Game NX݂̂̃\bhR[
		 */
		static bool _initialize(void);

		/**
		 * @brief m_pInputDevice ̉s
		 * @attention
		 *     Game NX݂̂̃\bhR[
		 */
		static void _shutdown(void);

		/**
		 * @brief Xe[g̍XVs
		 * @attention
		 *     Game NX݂̂̃\bhR[
		 */
		static void _update(void);

		/**
		 * @brief obNOEhp̍XV
		 * @attention
		 *     Game NX݂̂̃\bhR[
		 */
		static void _disupdate(void);

		/**
		 * @internal
		 * @brief foCX̍Ď擾
		 * @remarks
		 *      ̃o֐ Game NXɂăAvP[VANeBuɂȂۂɌĂяo܂B
		 */
		static void _acquire(void);

	public:
		/**
		 * @brief ݂̃}EXXe[g𓾂܂B
		 */
		static const MouseState &GetState(void);
	};
}

#endif